﻿Imports GrapeCity.Windows.SpreadSheet.UI.UndoRedo
Imports GrapeCity.Windows.SpreadSheet.UI
Imports GrapeCity.Windows.SpreadSheet.Data

Partial Public Class MainPage
    Inherits UserControl
    Public Sub New()
        InitializeComponent()
    End Sub
    Private Sub button1_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        gcSpreadSheet1.UndoManager.[Do](New AddRowsUndo(2, 3))
    End Sub
    Private Sub button2_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        gcSpreadSheet1.UndoManager.[Do](New RemoveRowsUndo(3, 2))
    End Sub
    Private Sub UserControl_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim sheet = gcSpreadSheet1.ActiveSheet
        sheet.RowCount = 20
        sheet.ColumnCount = 10
        For i As Integer = 0 To sheet.RowCount - 1
            For j As Integer = 0 To sheet.ColumnCount - 1
                sheet.SetValue(i, j, i + j)
            Next
        Next
    End Sub
End Class
Public Class AddRowsUndo
    Inherits ActionBase
    Implements IUndo
    Private _row As Integer
    Private _rowCount As Integer
    Public Sub New(row As Integer, rowCount As Integer)
        _row = row
        _rowCount = rowCount
    End Sub
    Public Overrides Function CanExecute(parameter As Object) As Boolean
        Return True
    End Function
    Public Overrides Sub Execute(parameter As Object)
        Dim sheet = TryCast(parameter, SpreadView).ActiveSheet
        sheet.AddRows(_row, _rowCount)
    End Sub
    Public ReadOnly Property CanUndo As Boolean Implements GrapeCity.Windows.SpreadSheet.UI.IUndo.CanUndo
        Get
            Return True
        End Get
    End Property
    Public Sub SaveState() Implements GrapeCity.Windows.SpreadSheet.UI.IUndo.SaveState

    End Sub
    Public Function Undo(parameter As Object) As Boolean Implements GrapeCity.Windows.SpreadSheet.UI.IUndo.Undo
        Try
            Dim sheet = TryCast(parameter, SpreadView).ActiveSheet
            sheet.RemoveRows(_row, _rowCount)
        Catch
            Return False
        End Try
        Return True
    End Function
End Class
Public Class RemoveRowsUndo
    Inherits ActionBase
    Implements IUndo
    Private _row As Integer
    Private _rowCount As Integer
    Private _clearValueAction As ClearValueUndoAction
    Public Sub New(row As Integer, rowCount As Integer)
        _row = row
        _rowCount = rowCount
    End Sub
    Public Overrides Function CanExecute(parameter As Object) As Boolean
        Return True
    End Function
    Public Overrides Sub Execute(parameter As Object)
        Dim sheet = TryCast(parameter, SpreadView).ActiveSheet
        _clearValueAction = New ClearValueUndoAction(sheet, New CellRange() {New CellRange(_row, -1, _rowCount, -1)})
        _clearValueAction.Execute(parameter)
        sheet.RemoveRows(_row, _rowCount)
    End Sub
    Public ReadOnly Property CanUndo As Boolean Implements GrapeCity.Windows.SpreadSheet.UI.IUndo.CanUndo
        Get
            Return True
        End Get
    End Property
    Public Sub SaveState() Implements GrapeCity.Windows.SpreadSheet.UI.IUndo.SaveState

    End Sub
    Public Function Undo(parameter As Object) As Boolean Implements GrapeCity.Windows.SpreadSheet.UI.IUndo.Undo
        Try
            Dim sheet = TryCast(parameter, SpreadView).ActiveSheet
            sheet.AddRows(_row, _rowCount)
            Me._clearValueAction.Undo(parameter)
        Catch
            Return False
        End Try
        Return True
    End Function
End Class

